zfsboottest.sh revision 236459
1#!/bin/sh
2#
3# Copyright (c) 2011 Pawel Jakub Dawidek <pawel@dawidek.net>
4# All rights reserved.
5#
6# Redistribution and use in source and binary forms, with or without
7# modification, are permitted provided that the following conditions
8# are met:
9# 1. Redistributions of source code must retain the above copyright
10#    notice, this list of conditions and the following disclaimer.
11# 2. Redistributions in binary form must reproduce the above copyright
12#    notice, this list of conditions and the following disclaimer in the
13#    documentation and/or other materials provided with the distribution.
14#
15# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
16# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
17# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
18# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
19# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
20# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
21# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
22# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
23# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
24# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
25# SUCH DAMAGE.
26#
27# $FreeBSD: stable/9/tools/tools/zfsboottest/zfsboottest.sh 236459 2012-06-02 18:24:43Z avg $
28
29if [ $# -ne 1 ]; then
30	echo "usage: zfsboottest.sh <pool>" >&2
31	exit 1
32fi
33
34which -s zfsboottest
35if [ $? -eq 0 ]; then
36	zfsboottest="zfsboottest"
37else
38	if [ ! -x "/usr/src/tools/tools/zfsboottest/zfsboottest" ]; then
39		echo "Unable to find \"zfsboottest\" utility." >&2
40		exit 1
41	fi
42	zfsboottest="/usr/src/tools/tools/zfsboottest/zfsboottest"
43fi
44
45startdir="/boot"
46
47pool="${1}"
48zpool list "${pool}" >/dev/null 2>&1
49if [ $? -ne 0 ]; then
50	echo "No such pool \"${pool}\"." >&2
51	exit 1
52fi
53bootfs=`zpool get bootfs "${pool}" | tail -1 | awk '{print $3}'`
54if [ "${bootfs}" = "-" ]; then
55	bootfs="${pool}"
56fi
57# Dataset's mountpoint property should be set to 'legacy'.
58if [ "`zfs get -H -o value mountpoint ${bootfs}`" != "legacy" ]; then
59	echo "The \"mountpoint\" property of dataset \"${bootfs}\" should be set to \"legacy\"." >&2
60	exit 1
61fi
62mountpoint=`df -t zfs "${bootfs}" 2>/dev/null | tail -1 | awk '{print $6}'`
63if [ -z "${mountpoint}" ]; then
64	echo "The \"${bootfs}\" dataset is not mounted." >&2
65	exit 1
66fi
67if [ ! -d "${mountpoint}${startdir}" ]; then
68	echo "The \"${mountpoint}${startdir}\" directory doesn't exist." >&2
69	exit 1
70fi
71# To be able to mount root ZFS file system we need either /etc/fstab entry
72# or vfs.root.mountfrom variable set in /boot/loader.conf.
73egrep -q '^'"${bootfs}"'[[:space:]]+/[[:space:]]+zfs[[:space:]]+' "${mountpoint}/etc/fstab" 2>/dev/null
74if [ $? -ne 0 ]; then
75	egrep -q 'vfs.root.mountfrom="?'"${bootfs}"'"?[[:space:]]*$' "${mountpoint}/boot/loader.conf" 2>/dev/null
76	if [ $? -ne 0 ]; then
77		echo "To be able to boot from \"${bootfs}\", you need to declare" >&2
78		echo "\"${bootfs}\" as being root file system in ${mountpoint}/etc/fstab" >&2
79		echo "or add \"vfs.root.mountfrom\" variable set to \"${bootfs}\" to" >&2
80		echo "${mountpoint}/boot/loader.conf." >&2
81		exit 1
82	fi
83fi
84vdevs=""
85for vdev in `zpool status "${pool}" | grep ONLINE | awk '{print $1}'`; do
86	vdev="/dev/${vdev#/dev/}"
87	if [ -c "${vdev}" ]; then
88		if [ -z "${vdevs}" ]; then
89			vdevs="${vdev}"
90		else
91			vdevs="${vdevs} ${vdev}"
92		fi
93	fi
94done
95
96list0=`mktemp /tmp/zfsboottest.XXXXXXXXXX`
97if [ $? -ne 0 ]; then
98	echo "Unable to create temporary file." >&2
99	exit 1
100fi
101list1=`mktemp /tmp/zfsboottest.XXXXXXXXXX`
102if [ $? -ne 0 ]; then
103	echo "Unable to create temporary file." >&2
104	rm -f "${list0}"
105	exit 1
106fi
107
108echo "zfsboottest.sh is reading all the files in ${mountpoint}${startdir} using"
109echo "boot code and using file system code."
110echo "It calculates MD5 checksums for all the files and will compare them."
111echo "If all files can be properly read using boot code, it is very likely you"
112echo "will be able to boot from \"${pool}\" pool>:> Good luck!"
113echo
114
115"${zfsboottest}" ${vdevs} - `find "${mountpoint}${startdir}" -type f | sed "s@^${mountpoint}@@"` | egrep '^[0-9a-z]{32} /' | sort -k 2 >"${list0}"
116find "${mountpoint}${startdir}" -type f | xargs md5 -r | sed "s@ ${mountpoint}@ @" | egrep '^[0-9a-z]{32} /' | sort -k 2 >"${list1}"
117
118diff -u "${list0}" "${list1}"
119ec=$?
120
121rm -f "${list0}" "${list1}"
122
123if [ $? -ne 0 ]; then
124	echo >&2
125	echo "You may not be able to boot." >&2
126	exit 1
127fi
128
129echo "OK"
130